#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>

using namespace std;

/**
    Ardelean Răzvan
    Soluție cautcuv - 100p

    Această soluție se bazează pe căutăre binară:
    După descompunerea textului în cuvinte folosind funcția strtok,
    Cuvintele se vor salva în două șiruri: în primul normal iar in al 2-lea cu toate literele majuscule.
    Se vor sorta ambele șiruri de cuvinte, folosind sortul din STL.
    Dacă o căutare este case sensitive se va căuta binar în primul șir, dacă nu, se va căuta binar în al doilea șir.
*/

int n, nCuv, nText;
char text[200010];
string cuvinteCs[20010];
string cuvinteNcs[20010];

void strUpr(char *s)
{
    int ns = strlen(s);
    for(int i = 0; i < ns; i++)
        if('a' <= s[i] && s[i] <= 'z')
            s[i] += 'A' - 'a';
}

void descompunere()
{
    char *p = strtok(text, " .,:;?!");
    while(p)
    {
        cuvinteCs[nCuv] = string(p);
        strupr(p);
        cuvinteNcs[nCuv] = string(p);
        nCuv++;
        p = strtok(NULL, " .,:;?!");
    }
}

int cautare (string cuv, string cuvinte[10010], int st = 0, int dr = nCuv-1)
{
    if(st > dr)
        return 0;

    int mid = (st+dr)/2;

    if(cuv == cuvinte[mid])
        return 1;
    else if(cuv < cuvinte[mid])
        return cautare(cuv, cuvinte, st, mid-1);
    else
        return cautare(cuv, cuvinte, mid+1, dr);
}

void rezolvare()
{
    char cuv[52];
    int cs;
    for(int i = 0; i < n; i++)
    {
        scanf("%s %d\n", cuv, &cs);
        if(cs)
            printf("%d\n", cautare(string(cuv), cuvinteCs));
        else
        {
            strupr(cuv);
            printf("%d\n", cautare(string(cuv), cuvinteNcs));
        }
    }
}

int main()
{
    freopen("cautcuv.in", "r", stdin);
    freopen("cautcuv.out", "w", stdout);

    gets(text);
    descompunere();
    scanf("%d\n", &n);
    sort(cuvinteCs, cuvinteCs + nCuv);
    sort(cuvinteNcs, cuvinteNcs + nCuv);

    rezolvare();

    return 0;
}
