#include <bits/stdc++.h>

using namespace std;

const int Nmax = 200005;
const double eps = 0.0000001;

int N, M;
double V;

template <typename T>
struct Point{
    T x, y;
    Point(T a, T b) {
        x = a;
        y = b;
    }
    Point() {
        x = y = 0;
    }
    double sqDist(Point other) {
        return (other.x - x)*(other.x - x) + (other.y - y)*(other.y - y);
    }
    double dist(Point other) {
        return sqrt(sqDist(other));
    }
};


double abso(double a) {
    if(a < 0)
        return -a;
    return a;
}

double equals(double a, double b) {
    return abso(a - b) < eps;
}

Point<double> H[Nmax];
Point<double> D[Nmax];

Point<double> advanceSegment(Point<double> A, Point<double> B, double percent)
{
    double dx = B.x - A.x;
    double dy = B.y - A.y;

    return Point<double>(A.x + percent * dx, A.y + percent * dy);
}

int main()
{
    freopen("hogwarts.in", "r", stdin);
    freopen("hogwarts.out", "w", stdout);

    ios::sync_with_stdio(false);
    cin >> N >> M >> V;

    for(int i = 1; i <= N; ++i) {
        double a,b;
        cin >> a >> b;
        H[i] = Point<double>(a, b); /// H[i] = {a, b};
    }

    for(int i = 1; i <= M; ++i) {
        double a,b;
        cin >> a >> b;
        D[i] = Point<double>(a, b);
    }

    int crtH, crtD;
    crtH = 0;
    crtD = 0; /// They are both at the beginning of the race

    Point<double> pctH, pctD, pctV, oldV;
    pctH = H[0];
    pctD = D[0]; /// The exact point they are at

    int nextH, nextD;
    double result = 0;

    while(crtH < N && crtD < M) {
        nextH = crtH + 1;
        nextD = crtD + 1;
        oldV = pctV;

        double timp1 = pctH.dist(H[nextH]);
        double timp2 = V*pctD.dist(D[nextD]);

        if(equals(timp1, timp2)) {
            crtH = nextH;
            crtD = nextD;
            pctH = H[crtH];
            pctD = D[crtD];

            pctV = Point<double>(2*pctH.x - pctD.x, 2*pctH.y - pctD.y);
            ///cerr << pctV.x << " " << pctV.y << endl;
            result += pctV.dist(oldV);
            continue;
        }

        if(timp1 < timp2) {
            crtH = nextH;
            pctH = H[crtH];
            double procent = timp1 / timp2;
            pctD = advanceSegment(pctD, D[nextD], procent);

            pctV = Point<double>(2*pctH.x - pctD.x, 2*pctH.y - pctD.y);
            ///cerr << pctV.x << " " << pctV.y << endl;
            result += pctV.dist(oldV);
            continue;
        }

        crtD = nextD;
        pctD = D[crtD];
        double procent = timp2 / timp1;
        pctH = advanceSegment(pctH, H[nextH], procent);

        pctV = Point<double>(2*pctH.x - pctD.x, 2*pctH.y - pctD.y);
        ///cerr << pctV.x << " " << pctV.y << endl;
        result += pctV.dist(oldV);
    }

    while(crtH < N) {
        crtH += 1;
        pctH = H[crtH];
        oldV = pctV;

        pctV = Point<double>(2*pctH.x - pctD.x, 2*pctH.y - pctD.y);
        result += pctV.dist(oldV);
        ///cerr << pctV.x << " " << pctV.y << endl;
    }

    while(crtD < M) {
        crtD += 1;
        pctD = D[crtD];
        oldV = pctV;

        pctV = Point<double>(2*pctH.x - pctD.x, 2*pctH.y - pctD.y);
        result += pctV.dist(oldV);
        ///cerr << pctV.x << " " << pctV.y << endl;
    }

    cout << setprecision(10) << fixed;
    cout << result;

    return 0;
}
